#ifndef COMMAND_H
#define COMMAND_H

#include "vulkan/vulkan_core.h"

typedef struct QueueStruct {
  VkQueue handle;
  uint32_t family;
  uint32_t index;
} Queue;


VkCommandBuffer command_begin_single(VkDevice device, VkCommandPool transfer_pool);

VkResult command_end_single(VkDevice device, VkCommandBuffer command_buffer, VkCommandPool transfer_pool, Queue transfer_queue);

VkResult command_transition_image_layout(VkDevice device, VkCommandPool transfer_pool, Queue transfer_queue, VkImageLayout old_layout, VkImageLayout new_layout, VkImage image, VkAccessFlags src_mask, VkAccessFlags dst_mask, VkPipelineStageFlags source, VkPipelineStageFlags dest, uint32_t source_family, uint32_t dest_family, VkImageAspectFlags aspect_flags);

#endif
